VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsBpca"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
'_/
'_/ [ clsBpca ]
'_/
'_/   --- Breakthrough in the Pseudo-Control-Array ---
'_/
'_/     Control: Label, CommandButton, TextBox, CheckBox
'_/              OptionButton, ToggleButton, ComboBox, SpinButton
'_/
'_/     AddinBox(K.Tsunoda) CopyRight(C) 2004 Allrights Reserved.
'_/       [http://addinbox.sakura.ne.jp/Breakthrough_P-Ctrl_Arrays_Eng.htm ]
'_/       [Old Site : http://www.h3.dion.ne.jp/~sakatsu/Breakthrough_P-Ctrl_Arrays_Eng.htm ]
'_/
'_/     22 Jun 2004 Ver1.0  1st version(Japanese)
'_/     23 Jun 2004 Ver1.1
'_/     10 Mar 2005 Ver1.2
'_/     15 Apr 2011 Ver1.3
'_/     22 Jul 2014 Ver1.4
'_/     24 Jul 2014 Ver1.4  (English version)
'_/
'_/  [clsBpcaCh / modBpcaConst] module is necessary together.
'_/
'_/  Cannot handle [Enter/Exit/BeforeUpdate/AfterUpdate]
'_/
'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

'(1) The event that you do not appoint by "Rgst method" does not occur
'    even if you prepare the Event-Procedure on the user side.

'(2) If the user side does not have the Event-Procedure, the event does
'    not happen even if you appoint it by "Rgst method".

'(3) The event that the control does not possess does not occur even
'    if you appoint it by "Rgst method".

'--------------------------------------------------------
Public Event Change(ByVal Index As Integer)
Public Event Click(ByVal Index As Integer)
Public Event DblClick(ByVal Index As Integer, ByVal Cancel As MSForms.ReturnBoolean)
Public Event KeyDown(ByVal Index As Integer, ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
Public Event KeyPress(ByVal Index As Integer, ByVal KeyAscii As MSForms.ReturnInteger)
Public Event KeyUp(ByVal Index As Integer, ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
Public Event MouseMove(ByVal Index As Integer, ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
Public Event MouseDown(ByVal Index As Integer, ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
Public Event MouseUp(ByVal Index As Integer, ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
Public Event DropButtonClick(ByVal Index As Integer)
Public Event SpinDown(ByVal Index As Integer)
Public Event SpinUp(ByVal Index As Integer)
'------------------------------------------------------------------
Private clsBpcaCtrlCh() As clsBpcaCh
Private colBpcaCtrlGrp As Collection

Private MyTypeName As String
Private blnAllType As Boolean
Private blnRgst As Boolean


'==============================================================
Private Sub Class_Initialize()
    Set colBpcaCtrlGrp = New Collection
    blnRgst = False
    blnAllType = False
    MyTypeName = ""
End Sub

'==================================================================
Private Sub Class_Terminate()
    If (blnRgst = True) Or (Not (colBpcaCtrlGrp Is Nothing)) Then
        Me.Clear
    End If
End Sub

'======== Property / Method definition =============================

'---( Add method )------------------------------------------------
'Add control to become array to collection.
Public Sub Add(ByVal NewCtrl As Object)
    If (blnRgst = False) Then
        colBpcaCtrlGrp.Add NewCtrl
    Else
        'Because Rgst method is executed, I do not add it.
    End If
End Sub

'---( Rgst method )------------------------------------------------
'I set the control that enrolled in collection in the array of the clsBpcaCh class.
'I receive the classification of the event to produce by an argument.
Public Sub Rgst(ByVal NewEvent As BPCA_Event, Optional ByVal AllType As Boolean = False)
Dim i As Integer
Dim blnERR As Boolean
    If (blnRgst = True) Then
        'Because Rgst method is executed, I do not handle it.
    ElseIf (colBpcaCtrlGrp.Count = 0) Then
        blnRgst = False
    Else
        blnAllType = AllType
        blnERR = False
        
        'In the case of "AllType=False", The control after the second
        'is the same as a type of the top control.
        MyTypeName = TypeName(colBpcaCtrlGrp(1))
        For i = 2 To colBpcaCtrlGrp.Count
            If (MyTypeName <> TypeName(colBpcaCtrlGrp(i))) Then
                If (blnAllType = False) Then
                    blnERR = True
                End If
            End If
        Next i
        If (blnERR = False) Then
          ReDim clsBpcaCtrlCh(1 To colBpcaCtrlGrp.Count)
          For i = 1 To colBpcaCtrlGrp.Count
            Set clsBpcaCtrlCh(i) = New clsBpcaCh
            With clsBpcaCtrlCh(i)
                .Item = colBpcaCtrlGrp(i)
                .Index = i
                .Parent = Me
                .EventSet = NewEvent
            End With
          Next i
          blnRgst = True
        End If
    End If
End Sub

'---( Clear method )-----------------------------
Public Sub Clear()
Dim i As Integer
    If (blnRgst = True) Then
        For i = 1 To colBpcaCtrlGrp.Count
            clsBpcaCtrlCh(i).Clear
        Next i
    End If
    Set colBpcaCtrlGrp = Nothing
    Erase clsBpcaCtrlCh
    blnRgst = False
End Sub

'---( Count property )---------------------------------------------
Public Property Get Count() As Integer
    Count = colBpcaCtrlGrp.Count
End Property

'---( getIndex property )---------------------------------------------
'It returns a value of "Index" becoming necessary for each property from a control name.
'In the case of a non-registration name, it returns -1.
Public Property Get getIndex(ByVal CtrlName As String) As Integer
Dim i As Integer
    getIndex = -1
    If (blnRgst = True) Then
        For i = 1 To colBpcaCtrlGrp.Count
            If (colBpcaCtrlGrp(i).Name = CtrlName) Then
                getIndex = i
                Exit For
            End If
        Next i
    Else
    End If
End Property

'---( EnableEvents property )----------------------------------------
Public Property Let EnableEvents(ByVal Index As Integer, ByVal NewEnableEvents As Boolean)
    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        clsBpcaCtrlCh(Index).EnableEvents = NewEnableEvents
    Else
    End If
End Property

Public Property Get EnableEvents(ByVal Index As Integer) As Boolean
    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        EnableEvents = clsBpcaCtrlCh(Index).EnableEvents
    Else
        EnableEvents = False
    End If
End Property

'---( EventState property )--------------------------------------------
' I return Variant array for the event raise classification
' that I received in EventSet property.
'  0: Long type, 1-12: Boolean type
'
'  [0] The numerical value that I received in EventSet
'  [1] Change, [2] Click, [3] DblClick
'  [4] KeyDown, [5] KeyPress, [6] KeyUp
'  [7] MouseMove, [8] MouseDown, [9] MouseUp
'  [10] DropBtnClick, [11] SpinDown, [12] SpinUp
Public Property Get EventState() As Variant
    If (blnRgst = True) Then
        EventState = clsBpcaCtrlCh(1).EventState
    Else
        EventState = Empty
    End If
End Property

'---( Item property : Default property)----------------------------
'I return individual control objects from the control array.

Public Property Get Item(ByVal Index As Integer) As Object
Attribute Item.VB_UserMemId = 0
' Attribute Item.VB_UserMemId = 0

'(Note)
'The Item property becomes the Default property.
'The statement("Attribute Item.VB_UserMemId = 0") mentioned above is added
'to this part of the class module to assume it the Default property
'(you do not watch it from a code window).
'If you watch the export file of this class module, you can confirm it.

    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        Set Item = colBpcaCtrlGrp(Index)
    Else
        Set Item = Nothing
    End If
End Property

'---( ItmXXX property )-------------------------------------------
'I return individual control objects from the control array.
'I return MsForms type to a type of the control.
Public Property Get ItmLbl(ByVal Index As Integer) As MSForms.Label
Dim strTypeName As String
    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        If (blnAllType = False) Then
            strTypeName = MyTypeName
        Else
            strTypeName = TypeName(colBpcaCtrlGrp(Index))
        End If
        If (strTypeName = "Label") Then
                Set ItmLbl = colBpcaCtrlGrp(Index)
        Else
            Set ItmLbl = Nothing
        End If
    Else
        Set ItmLbl = Nothing
    End If
End Property

Public Property Get ItmCmd(ByVal Index As Integer) As MSForms.CommandButton
Dim strTypeName As String
    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        If (blnAllType = False) Then
            strTypeName = MyTypeName
        Else
            strTypeName = TypeName(colBpcaCtrlGrp(Index))
        End If
        If (strTypeName = "CommandButton") Then
            Set ItmCmd = colBpcaCtrlGrp(Index)
        Else
            Set ItmCmd = Nothing
        End If
    Else
        Set ItmCmd = Nothing
    End If
End Property

Public Property Get ItmTxt(ByVal Index As Integer) As MSForms.TextBox
Dim strTypeName As String
    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        If (blnAllType = False) Then
            strTypeName = MyTypeName
        Else
            strTypeName = TypeName(colBpcaCtrlGrp(Index))
        End If
        If (strTypeName = "TextBox") Then
            Set ItmTxt = colBpcaCtrlGrp(Index)
        Else
            Set ItmTxt = Nothing
        End If
    Else
        Set ItmTxt = Nothing
    End If
End Property

Public Property Get ItmChk(ByVal Index As Integer) As MSForms.CheckBox
Dim strTypeName As String
    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        If (blnAllType = False) Then
            strTypeName = MyTypeName
        Else
            strTypeName = TypeName(colBpcaCtrlGrp(Index))
        End If
        If (strTypeName = "CheckBox") Then
            Set ItmChk = colBpcaCtrlGrp(Index)
        Else
            Set ItmChk = Nothing
        End If
    Else
        Set ItmChk = Nothing
    End If
End Property

Public Property Get ItmOpt(ByVal Index As Integer) As MSForms.OptionButton
Dim strTypeName As String
    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        If (blnAllType = False) Then
            strTypeName = MyTypeName
        Else
            strTypeName = TypeName(colBpcaCtrlGrp(Index))
        End If
        If (strTypeName = "OptionButton") Then
            Set ItmOpt = colBpcaCtrlGrp(Index)
        Else
            Set ItmOpt = Nothing
        End If
    Else
        Set ItmOpt = Nothing
    End If
End Property

Public Property Get ItmTgl(ByVal Index As Integer) As MSForms.ToggleButton
Dim strTypeName As String
    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        If (blnAllType = False) Then
            strTypeName = MyTypeName
        Else
            strTypeName = TypeName(colBpcaCtrlGrp(Index))
        End If
        If (strTypeName = "ToggleButton") Then
            Set ItmTgl = colBpcaCtrlGrp(Index)
        Else
            Set ItmTgl = Nothing
        End If
    Else
        Set ItmTgl = Nothing
    End If
End Property

Public Property Get ItmCbo(ByVal Index As Integer) As MSForms.ComboBox
Dim strTypeName As String
    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        If (blnAllType = False) Then
            strTypeName = MyTypeName
        Else
            strTypeName = TypeName(colBpcaCtrlGrp(Index))
        End If
        If (strTypeName = "ComboBox") Then
            Set ItmCbo = colBpcaCtrlGrp(Index)
        Else
            Set ItmCbo = Nothing
        End If
    Else
        Set ItmCbo = Nothing
    End If
End Property

Public Property Get ItmSpn(ByVal Index As Integer) As MSForms.SpinButton
Dim strTypeName As String
    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        If (blnAllType = False) Then
            strTypeName = MyTypeName
        Else
            strTypeName = TypeName(colBpcaCtrlGrp(Index))
        End If
        If (strTypeName = "SpinButton") Then
            Set ItmSpn = colBpcaCtrlGrp(Index)
        Else
            Set ItmSpn = Nothing
        End If
    Else
        Set ItmSpn = Nothing
    End If
End Property

'===================================================================
' Event excitation method to be called from clsBpcaCh
'===================================================================
Public Sub RaiseChange(ByVal Index As Integer)
    RaiseEvent Change(Index)
End Sub

Public Sub RaiseClick(ByVal Index As Integer)
    RaiseEvent Click(Index)
End Sub

Public Sub RaiseDblClick(ByVal Index As Integer, _
                         ByVal Cancel As MSForms.ReturnBoolean)
    RaiseEvent DblClick(Index, Cancel)
End Sub

Public Sub RaiseKeyDown(ByVal Index As Integer, _
                        ByVal KeyCode As MSForms.ReturnInteger, _
                        ByVal Shift As Integer)
    RaiseEvent KeyDown(Index, KeyCode, Shift)
End Sub

Public Sub RaiseKeyPress(ByVal Index As Integer, _
                         ByVal KeyAscii As MSForms.ReturnInteger)
    RaiseEvent KeyPress(Index, KeyAscii)
End Sub

Public Sub RaiseKeyUp(ByVal Index As Integer, _
                      ByVal KeyCode As MSForms.ReturnInteger, _
                      ByVal Shift As Integer)
    RaiseEvent KeyUp(Index, KeyCode, Shift)
End Sub

Public Sub RaiseMouseMove(ByVal Index As Integer, _
                          ByVal Button As Integer, _
                          ByVal Shift As Integer, _
                          ByVal X As Single, _
                          ByVal Y As Single)
    RaiseEvent MouseMove(Index, Button, Shift, X, Y)
End Sub

Public Sub RaiseMouseDown(ByVal Index As Integer, _
                          ByVal Button As Integer, _
                          ByVal Shift As Integer, _
                          ByVal X As Single, _
                          ByVal Y As Single)
    RaiseEvent MouseDown(Index, Button, Shift, X, Y)
End Sub

Public Sub RaiseMouseUp(ByVal Index As Integer, _
                        ByVal Button As Integer, _
                        ByVal Shift As Integer, _
                        ByVal X As Single, _
                        ByVal Y As Single)
    RaiseEvent MouseUp(Index, Button, Shift, X, Y)
End Sub

Public Sub RaiseDropButtonClick(ByVal Index As Integer)
    RaiseEvent DropButtonClick(Index)
End Sub

Public Sub RaiseSpinDown(ByVal Index As Integer)
    RaiseEvent SpinDown(Index)
End Sub

Public Sub RaiseSpinUp(ByVal Index As Integer)
    RaiseEvent SpinUp(Index)
End Sub



