VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsBpcaCh"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
'_/
'_/ [ clsBpcaCh ]
'_/
'_/   --- Breakthrough in the Pseudo-Control-Array ---
'_/
'_/     Control: Label, CommandButton, TextBox, CheckBox
'_/              OptionButton, ToggleButton, ComboBox, SpinButton
'_/
'_/     AddinBox(K.Tsunoda) CopyRight(C) 2004 Allrights Reserved.
'_/       [http://addinbox.sakura.ne.jp/Breakthrough_P-Ctrl_Arrays_Eng.htm ]
'_/       [Old Site : http://www.h3.dion.ne.jp/~sakatsu/Breakthrough_P-Ctrl_Arrays_Eng.htm ]
'_/
'_/
'_/  The clsBpcaCh class works as a child class of the clsBpca class.
'_/  The user does not use the clsBpcaCh class.
'_/
'_/  [modBpcaConst] module is necessary together.
'_/
'_/  Cannot handle [Enter/Exit/BeforeUpdate/AfterUpdate]
'_/
'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/


'----------------------------------------------------
Private WithEvents MyCtrlLbl As MSForms.Label
Attribute MyCtrlLbl.VB_VarHelpID = -1
Private WithEvents MyCtrlCmd As MSForms.CommandButton
Attribute MyCtrlCmd.VB_VarHelpID = -1
Private WithEvents MyCtrlTxt As MSForms.TextBox
Attribute MyCtrlTxt.VB_VarHelpID = -1
Private WithEvents MyCtrlChk As MSForms.CheckBox
Attribute MyCtrlChk.VB_VarHelpID = -1
Private WithEvents MyCtrlOpt As MSForms.OptionButton
Attribute MyCtrlOpt.VB_VarHelpID = -1
Private WithEvents MyCtrlTgl As MSForms.ToggleButton
Attribute MyCtrlTgl.VB_VarHelpID = -1
Private WithEvents MyCtrlCbo As MSForms.ComboBox
Attribute MyCtrlCbo.VB_VarHelpID = -1
Private WithEvents MyCtrlSpn As MSForms.SpinButton
Attribute MyCtrlSpn.VB_VarHelpID = -1

Private MyCtrl As Object
Attribute MyCtrl.VB_VarHelpID = -1
Private MyIndex As Integer
Private MyParent As clsBpca
Private MyEnableEvents As Boolean

Private blnParent As Boolean

'---------------------------------------------------
'Raise Event(Enable or Not enable)
Private lngEventState As Long
Private blnEventChange As Boolean
Private blnEventClick As Boolean
Private blnEventDblClick As Boolean
Private blnEventKeyDown As Boolean
Private blnEventKeyPress As Boolean
Private blnEventKeyUp As Boolean
Private blnEventMouseMove As Boolean
Private blnEventMouseDown As Boolean
Private blnEventMouseUp As Boolean
Private blnEventDropBtnClick As Boolean
Private blnEventSpinDown As Boolean
Private blnEventSpinUp As Boolean

'=============================================
Private Sub Class_Initialize()
    blnParent = False
    MyIndex = 0
    MyEnableEvents = True
End Sub

'=============================================
Public Sub Clear()
    Set MyCtrlLbl = Nothing
    Set MyCtrlCmd = Nothing
    Set MyCtrlTxt = Nothing
    Set MyCtrlChk = Nothing
    Set MyCtrlOpt = Nothing
    Set MyCtrlTgl = Nothing
    Set MyCtrlCbo = Nothing
    Set MyCtrlSpn = Nothing

    Set MyCtrl = Nothing
    Set MyParent = Nothing
    blnParent = False
    MyIndex = 0
End Sub

'=============================================
Public Property Let Item(NewCtrl As Object)
    Set MyCtrl = NewCtrl
    
    Select Case TypeName(NewCtrl)
      Case "Label": Set MyCtrlLbl = NewCtrl
      Case "CommandButton": Set MyCtrlCmd = NewCtrl
      Case "TextBox": Set MyCtrlTxt = NewCtrl
      Case "CheckBox": Set MyCtrlChk = NewCtrl
      Case "OptionButton": Set MyCtrlOpt = NewCtrl
      Case "ToggleButton": Set MyCtrlTgl = NewCtrl
      Case "ComboBox": Set MyCtrlCbo = NewCtrl
      Case "SpinButton": Set MyCtrlSpn = NewCtrl
    End Select
End Property

Public Property Get Item() As Object
    Set Item = MyCtrl
End Property

'=============================================
Public Property Let Index(NewIndex As Integer)
    MyIndex = NewIndex
End Property

Public Property Get Index() As Integer
    Index = MyIndex
End Property

'=============================================
Public Property Let EnableEvents(NewEnableEvents As Boolean)
    MyEnableEvents = NewEnableEvents
End Property

Public Property Get EnableEvents() As Boolean
    EnableEvents = MyEnableEvents
End Property

'=============================================
'clsBpca class of the parent of this class
Public Property Let Parent(NewParent As clsBpca)
    blnParent = True
    Set MyParent = NewParent
End Property

Public Property Get Parent() As clsBpca
    Set Parent = MyParent
End Property

'=============================================
Public Property Let EventSet(NewEvent As Long)
'Break numerical value into a bit and substitute it for each flag

    lngEventState = NewEvent
    
    blnEventChange = ((NewEvent And BPCA_Change) = BPCA_Change)
    blnEventClick = ((NewEvent And BPCA_Click) = BPCA_Click)
    blnEventDblClick = ((NewEvent And BPCA_DblClick) = BPCA_DblClick)
    blnEventKeyDown = ((NewEvent And BPCA_KeyDown) = BPCA_KeyDown)
    blnEventKeyPress = ((NewEvent And BPCA_KeyPress) = BPCA_KeyPress)
    blnEventKeyUp = ((NewEvent And BPCA_KeyUp) = BPCA_KeyUp)
    blnEventMouseMove = ((NewEvent And BPCA_MouseMove) = BPCA_MouseMove)
    blnEventMouseDown = ((NewEvent And BPCA_MouseDown) = BPCA_MouseDown)
    blnEventMouseUp = ((NewEvent And BPCA_MouseUp) = BPCA_MouseUp)
    blnEventDropBtnClick = ((NewEvent And BPCA_DropBtnClick) = BPCA_DropBtnClick)
    blnEventSpinDown = ((NewEvent And BPCA_SpinDown) = BPCA_SpinDown)
    blnEventSpinUp = ((NewEvent And BPCA_SpinUp) = BPCA_SpinUp)
End Property

'=============================================
' I return Variant array for the event raise classification
' that I received in EventSet property.
'  0: Long type, 1-12: Boolean type
'
'  [0] The numerical value that I received in EventSet
'  [1] Change, [2]Click, [3]DblClick
'  [4] KeyDown, [5]KeyPress, [6]KeyUp
'  [7] MouseMove, [8]MouseDown, [9]MouseUp
'  [10] DropBtnClick), [11]SpinDown, [12]SpinUp

Public Property Get EventState() As Variant
    EventState = Array(lngEventState, _
                       blnEventChange, blnEventClick, blnEventDblClick, _
                       blnEventKeyDown, blnEventKeyPress, blnEventKeyUp, _
                       blnEventMouseMove, blnEventMouseDown, blnEventMouseUp, _
                       blnEventDropBtnClick, blnEventSpinDown, blnEventSpinUp)
End Property

'===================================================================

'----[ Label ]--------------------------------------
Private Sub MyCtrlLbl_Click()
    If (blnParent And blnEventClick And MyEnableEvents) Then
        MyParent.RaiseClick MyIndex
    End If
End Sub

Private Sub MyCtrlLbl_DblClick(ByVal Cancel As MSForms.ReturnBoolean)
    If (blnParent And blnEventDblClick And MyEnableEvents) Then
        MyParent.RaiseDblClick MyIndex, Cancel
    End If
End Sub

Private Sub MyCtrlLbl_MouseMove(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseMove And MyEnableEvents) Then
        MyParent.RaiseMouseMove MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlLbl_MouseDown(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseDown And MyEnableEvents) Then
        MyParent.RaiseMouseDown MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlLbl_MouseUp(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseUp And MyEnableEvents) Then
        MyParent.RaiseMouseUp MyIndex, Button, Shift, X, Y
    End If
End Sub

'----[ CommandButton ]--------------------------------------
Private Sub MyCtrlCmd_Click()
    If (blnParent And blnEventClick And MyEnableEvents) Then
        MyParent.RaiseClick MyIndex
    End If
End Sub

Private Sub MyCtrlCmd_DblClick(ByVal Cancel As MSForms.ReturnBoolean)
    If (blnParent And blnEventDblClick And MyEnableEvents) Then
        MyParent.RaiseDblClick MyIndex, Cancel
    End If
End Sub

Private Sub MyCtrlCmd_KeyDown(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyDown And MyEnableEvents) Then
        MyParent.RaiseKeyDown MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlCmd_KeyPress(ByVal KeyAscii As MSForms.ReturnInteger)
    If (blnParent And blnEventKeyPress And MyEnableEvents) Then
        MyParent.RaiseKeyPress MyIndex, KeyAscii
    End If
End Sub

Private Sub MyCtrlCmd_KeyUp(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyUp And MyEnableEvents) Then
        MyParent.RaiseKeyUp MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlCmd_MouseMove(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseMove And MyEnableEvents) Then
        MyParent.RaiseMouseMove MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlCmd_MouseDown(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseDown And MyEnableEvents) Then
        MyParent.RaiseMouseDown MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlCmd_MouseUp(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseUp And MyEnableEvents) Then
        MyParent.RaiseMouseUp MyIndex, Button, Shift, X, Y
    End If
End Sub

'----[ TextBox ]--------------------------------------
Private Sub MyCtrlTxt_Change()
    If (blnParent And blnEventChange And MyEnableEvents) Then
        MyParent.RaiseChange MyIndex
    End If
End Sub

Private Sub MyCtrlTxt_DblClick(ByVal Cancel As MSForms.ReturnBoolean)
    If (blnParent And blnEventDblClick And MyEnableEvents) Then
        MyParent.RaiseDblClick MyIndex, Cancel
    End If
End Sub

Private Sub MyCtrlTxt_KeyDown(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyDown And MyEnableEvents) Then
        MyParent.RaiseKeyDown MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlTxt_KeyPress(ByVal KeyAscii As MSForms.ReturnInteger)
    If (blnParent And blnEventKeyPress And MyEnableEvents) Then
        MyParent.RaiseKeyPress MyIndex, KeyAscii
    End If
End Sub

Private Sub MyCtrlTxt_KeyUp(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyUp And MyEnableEvents) Then
        MyParent.RaiseKeyUp MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlTxt_MouseMove(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseMove And MyEnableEvents) Then
        MyParent.RaiseMouseMove MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlTxt_MouseDown(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseDown And MyEnableEvents) Then
        MyParent.RaiseMouseDown MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlTxt_MouseUp(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseUp And MyEnableEvents) Then
        MyParent.RaiseMouseUp MyIndex, Button, Shift, X, Y
    End If
End Sub

'----[ CheckBox ]--------------------------------------
Private Sub MyCtrlChk_Change()
    If (blnParent And blnEventChange And MyEnableEvents) Then
        MyParent.RaiseChange MyIndex
    End If
End Sub

Private Sub MyCtrlChk_Click()
    If (blnParent And blnEventClick And MyEnableEvents) Then
        MyParent.RaiseClick MyIndex
    End If
End Sub

Private Sub MyCtrlChk_DblClick(ByVal Cancel As MSForms.ReturnBoolean)
    If (blnParent And blnEventDblClick And MyEnableEvents) Then
        MyParent.RaiseDblClick MyIndex, Cancel
    End If
End Sub

Private Sub MyCtrlChk_KeyDown(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyDown And MyEnableEvents) Then
        MyParent.RaiseKeyDown MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlChk_KeyPress(ByVal KeyAscii As MSForms.ReturnInteger)
    If (blnParent And blnEventKeyPress And MyEnableEvents) Then
        MyParent.RaiseKeyPress MyIndex, KeyAscii
    End If
End Sub

Private Sub MyCtrlChk_KeyUp(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyUp And MyEnableEvents) Then
        MyParent.RaiseKeyUp MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlChk_MouseMove(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseMove And MyEnableEvents) Then
        MyParent.RaiseMouseMove MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlChk_MouseDown(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseDown And MyEnableEvents) Then
        MyParent.RaiseMouseDown MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlChk_MouseUp(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseUp And MyEnableEvents) Then
        MyParent.RaiseMouseUp MyIndex, Button, Shift, X, Y
    End If
End Sub

'----[ OptionButtton ]--------------------------------------
Private Sub MyCtrlOpt_Change()
    If (blnParent And blnEventChange And MyEnableEvents) Then
        MyParent.RaiseChange MyIndex
    End If
End Sub

Private Sub MyCtrlOpt_Click()
    If (blnParent And blnEventClick And MyEnableEvents) Then
        MyParent.RaiseClick MyIndex
    End If
End Sub

Private Sub MyCtrlOpt_DblClick(ByVal Cancel As MSForms.ReturnBoolean)
    If (blnParent And blnEventDblClick And MyEnableEvents) Then
        MyParent.RaiseDblClick MyIndex, Cancel
    End If
End Sub

Private Sub MyCtrlOpt_KeyDown(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyDown And MyEnableEvents) Then
        MyParent.RaiseKeyDown MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlOpt_KeyPress(ByVal KeyAscii As MSForms.ReturnInteger)
    If (blnParent And blnEventKeyPress And MyEnableEvents) Then
        MyParent.RaiseKeyPress MyIndex, KeyAscii
    End If
End Sub

Private Sub MyCtrlOpt_KeyUp(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyUp And MyEnableEvents) Then
        MyParent.RaiseKeyUp MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlOpt_MouseMove(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseMove And MyEnableEvents) Then
        MyParent.RaiseMouseMove MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlOpt_MouseDown(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseDown And MyEnableEvents) Then
        MyParent.RaiseMouseDown MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlOpt_MouseUp(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseUp And MyEnableEvents) Then
        MyParent.RaiseMouseUp MyIndex, Button, Shift, X, Y
    End If
End Sub

'----[ ToggleButtton ]--------------------------------------
Private Sub MyCtrlTgl_Change()
    If (blnParent And blnEventChange And MyEnableEvents) Then
        MyParent.RaiseChange MyIndex
    End If
End Sub

Private Sub MyCtrlTgl_Click()
    If (blnParent And blnEventClick And MyEnableEvents) Then
        MyParent.RaiseClick MyIndex
    End If
End Sub

Private Sub MyCtrlTgl_DblClick(ByVal Cancel As MSForms.ReturnBoolean)
    If (blnParent And blnEventDblClick And MyEnableEvents) Then
        MyParent.RaiseDblClick MyIndex, Cancel
    End If
End Sub

Private Sub MyCtrlTgl_KeyDown(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyDown And MyEnableEvents) Then
        MyParent.RaiseKeyDown MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlTgl_KeyPress(ByVal KeyAscii As MSForms.ReturnInteger)
    If (blnParent And blnEventKeyPress And MyEnableEvents) Then
        MyParent.RaiseKeyPress MyIndex, KeyAscii
    End If
End Sub

Private Sub MyCtrlTgl_KeyUp(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyUp And MyEnableEvents) Then
        MyParent.RaiseKeyUp MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlOTgl_MouseMove(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseMove And MyEnableEvents) Then
        MyParent.RaiseMouseMove MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlTgl_MouseDown(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseDown And MyEnableEvents) Then
        MyParent.RaiseMouseDown MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlTgl_MouseUp(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseUp And MyEnableEvents) Then
        MyParent.RaiseMouseUp MyIndex, Button, Shift, X, Y
    End If
End Sub

'----[ ComboBox ]--------------------------------------
Private Sub MyCtrlCbo_Change()
    If (blnParent And blnEventChange And MyEnableEvents) Then
        MyParent.RaiseChange MyIndex
    End If
End Sub

Private Sub MyCtrlCbo_Click()
    If (blnParent And blnEventClick And MyEnableEvents) Then
        MyParent.RaiseClick MyIndex
    End If
End Sub

Private Sub MyCtrlCbo_DblClick(ByVal Cancel As MSForms.ReturnBoolean)
    If (blnParent And blnEventDblClick And MyEnableEvents) Then
        MyParent.RaiseDblClick MyIndex, Cancel
    End If
End Sub

Private Sub MyCtrlCbo_KeyDown(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyDown And MyEnableEvents) Then
        MyParent.RaiseKeyDown MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlCbo_KeyPress(ByVal KeyAscii As MSForms.ReturnInteger)
    If (blnParent And blnEventKeyPress And MyEnableEvents) Then
        MyParent.RaiseKeyPress MyIndex, KeyAscii
    End If
End Sub

Private Sub MyCtrlCbo_KeyUp(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyUp And MyEnableEvents) Then
        MyParent.RaiseKeyUp MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlCbo_MouseMove(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseMove And MyEnableEvents) Then
        MyParent.RaiseMouseMove MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlCbo_MouseDown(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseDown And MyEnableEvents) Then
        MyParent.RaiseMouseDown MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlCbo_MouseUp(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseUp And MyEnableEvents) Then
        MyParent.RaiseMouseUp MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlCbo_DropButtonClick()
    If (blnParent And blnEventDropBtnClick And MyEnableEvents) Then
        MyParent.RaiseDropButtonClick MyIndex
    End If
End Sub

'----[ SpinButton ]--------------------------------------
Private Sub MyCtrlSpn_Change()
    If (blnParent And blnEventChange And MyEnableEvents) Then
        MyParent.RaiseChange MyIndex
    End If
End Sub

Private Sub MyCtrlSpn_KeyDown(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyDown And MyEnableEvents) Then
        MyParent.RaiseKeyDown MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlSpn_KeyPress(ByVal KeyAscii As MSForms.ReturnInteger)
    If (blnParent And blnEventKeyPress And MyEnableEvents) Then
        MyParent.RaiseKeyPress MyIndex, KeyAscii
    End If
End Sub

Private Sub MyCtrlSpn_KeyUp(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyUp And MyEnableEvents) Then
        MyParent.RaiseKeyUp MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlSpn_SpinDown()
    If (blnParent And blnEventSpinDown And MyEnableEvents) Then
        MyParent.RaiseSpinDown MyIndex
    End If
End Sub

Private Sub MyCtrlSpn_SpinUp()
    If (blnParent And blnEventSpinUp And MyEnableEvents) Then
        MyParent.RaiseSpinUp MyIndex
    End If
End Sub



